package ws.prova.reference;

/*
 * Copyright (C) 1999-2005 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import org.mandarax.kernel.AbstractPropertiesSupport;
import org.mandarax.kernel.DerivationEventListener;
import org.mandarax.kernel.Fact;
import org.mandarax.kernel.Query;

/**
 * Reference implementation of the Query interface.
 * <p><strong>Warning:</strong>This class should only be instanciated through a logic factory object.
 * This class is public and has public constructors only to support tools based on the bean component model
 * such as xml serialization.
 *
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 1.9
 */
public class QueryImpl extends AbstractPropertiesSupport implements Query {

	private Fact[] facts = null;
	private DerivationEventListener[] derivationEventListeners = null;
	private String name = null;

	/**
	 * Constructor.
	 */
	public QueryImpl() {
		super();
	}

	/**
	 * Constructor.
	 */
	QueryImpl(Fact[] facts, String name) {
		super();
		this.facts = facts;
		this.name = name;
	}

	/**
	 * Check whether objects are equal.
	 *
	 * @param obj the object to compare this object with
	 * @return true if the objects are equal, false otherwise
	 */
	public boolean equals(Object obj) {
		if ((obj != null) && (obj instanceof QueryImpl)) {
			QueryImpl aQuery = (QueryImpl) obj;
			boolean result = (name == null ? aQuery.getName() == null : true);
			result = result && name.equals(aQuery.getName());
			Fact[] ff = aQuery.getFacts();
			result = result && (facts == null ? ff == null : true);
			result = result && (facts.length == ff.length);
			for (int i = 0; i < facts.length; i++) {
				result = result && (facts[i].equals(ff[i]));
			}
			return result;
		}
		return false;
	}

	/**
	 * Get the hashcode of the object.
	 *
	 * @return an integer
	 */
	public int hashCode() {
		int i1 = name == null ? 0 : name.hashCode();
		if (facts == null || facts.length == 0)
			return i1;
		else
			return i1 ^ facts[0].hashCode();
	}

	/**
	 * Get the facts.
	 *
	 * @return an array of facts
	 * @see org.mandarax.kernel.Fact
	 */
	public Fact[] getFacts() {
		return facts;
	}

	/**
	 * Set the facts.
	 *
	 * @param facts an array of facts
	 * @see org.mandarax.kernel.Fact
	 */
	public void setFacts(Fact[] facts) {
		this.facts = facts;
	}

	/**
	 * Get the common name of this query, i.e., something like "Find the oncle of a person".
	 *
	 * @return a string
	 */
	public String getName() {
		return name;
	}

	/**
	 * Set the common name of this query.
	 *
	 * @param a name
	 */
	public void setName(String queryName) {
		name = queryName;
	}

	/**
	 * Get the registered derivation event listeners.
	 *
	 * @return an array of listeners
	 */
	public DerivationEventListener[] getDerivationEventListeners() {
		return derivationEventListeners;
	}

	/**
	 * Set the derivation event listeners.
	 *
	 * @param listeners listeners
	 */
	public void setDerivationEventListeners(DerivationEventListener[] listeners) {
		derivationEventListeners = listeners;
	}

}
